//
//  ViewController.m
//  RecordTool
//
//  Created by apple on 2017/9/26.
//  Copyright © 2017年 JIABIANWANGLUO. All rights reserved.
//

#import "ViewController.h"
#import "RecordTool.h"
#import "BTVoicePlayer.h"

@interface ViewController ()

@property (nonatomic, strong) RecordTool *tool;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event {
    AVAuthorizationStatus videoAuthStatus = [AVCaptureDevice authorizationStatusForMediaType:AVMediaTypeAudio];
    if (videoAuthStatus == AVAuthorizationStatusNotDetermined) {// 未询问用户是否授权
        //第一次询问用户是否进行授权
        [[AVAudioSession sharedInstance] requestRecordPermission:^(BOOL granted) {
            // CALL YOUR METHOD HERE - as this assumes being called only once from user interacting with permission alert!
            if (granted) {
                // 同意授权
                
            }
            else {
                NSLog(@"不同意");
                
            }
        }];
    }
    else if(videoAuthStatus == AVAuthorizationStatusRestricted || videoAuthStatus == AVAuthorizationStatusDenied) {
        // 未授权
        [self showSetAlertView];
    }
    else{// 已授权
        NSLog(@"已授权");
    }
}

//提示用户进行麦克风使用授权
- (void)showSetAlertView {
    UIAlertController *alertVC = [UIAlertController alertControllerWithTitle:@"麦克风权限未开启" message:@"麦克风权限未开启，请进入系统【设置】>【隐私】>【麦克风】中打开开关,开启麦克风功能" preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        
    }];
//    UIAlertAction *setAction = [UIAlertAction actionWithTitle:@"去设置" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
//        //跳入当前App设置界面
//        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:UIApplicationOpenSettingsURLString]];
//    }];
    [alertVC addAction:cancelAction];
//    [alertVC addAction:setAction];
    
    [self presentViewController:alertVC animated:YES completion:nil];
}


- (IBAction)first:(id)sender {
    self.tool = [RecordTool sharedInstance];
    [self.tool startRecordVoice];
    self.tool.finishBlock = ^(NSString *wavpath,NSString *mp3path,float recordTime) {
        NSLog(@"%f",recordTime);
        [RecordTool convertWavToMp3:wavpath withSavePath:mp3path withBlock:^(NSString *errorInfo) {
            if (!errorInfo) {
                NSLog(@"转化成功!");
                if (recordTime == 4.0) {
                    NSLog(@"zidongjieshu");
                }
            }
            
        }];
    };

}

- (IBAction)second:(id)sender {
    NSLog(@"正在上传");
    self.tool = [RecordTool sharedInstance];
    if (self.tool.mp3SavePath.length != 0) {
        [self.tool stopRecordVoice];
    }
    
    
}

- (IBAction)third:(id)sender {
    
    self.tool = [RecordTool sharedInstance];
    if (self.tool.mp3SavePath.length != 0) {
        [[BTVoicePlayer share]play:self.tool.mp3SavePath];
    }
    
}

@end
